function [ output_args ] = getArrivalTimes( input_args )
%UNNAMED Summary of this function goes here
%   Detailed explanation goes here
X = xlsread('FinLocalEarthq.xls');
[locations stations] = xlsread('stations.xls');
T = getTime(X);

fileID = fopen('output.txt','w');
fclose(fileID);

for f = 1:size(T, 1)
    
    year = T(f, 1);
    day = T(f, 2);
    hour = T(f, 3);
    minute = T(f, 4);
    second = T(f, 5);
    
    origin = [year day hour minute second];

    month = X(f, 2);
    dayOfMonth = X(f, 3);

      % event window:
      % hour1:minute1:second1 -- hour2:minute2:second2

      hour1 = hour;
      minute1 = minute - 15;
      second1 = second;

      if minute1 < 0
        hour1 = hour1 - 1;
        minute1 = minute1 + 60;

        if hour1 < 0
          hour1 = 23;
        end
      end

      hour2 = hour;
      minute2 = minute + 30;
      second2 = second;

      if minute2 > 59
        hour2 = hour2 + 1;
        minute2 = minute2 - 60;

        if hour2 > 23
          hour2 = 0;
        end
      end

      % datenumbers of the start and the end of the event window:
      dn1 = datenum([year month dayOfMonth hour1 minute1 second1]);
      dn2 = datenum([year month dayOfMonth hour2 minute2 second2]);
      
      dnOrigin = datenum([year month dayOfMonth hour minute second]);


    files = dir(strcat('*.', int2str(year), '.', int2str(day), '.mseed'));

    
    for i = 1: min(1,size(files, 1)) %size(files, 1)

      D = rdmseed(files(i).name);

      k1 = 1;
      while D(k1).t(1) < dn1
        k1 = k1 + 1;
      end
      k1 = k1 - 1;
      k2 = k1;
      k0 = k1;
      while D(k2).t(1) < dn2
        if D(k0).t(1) < dnOrigin
           k0 = k0 + 1;
        end
        k2 = k2 + 1;
      end
      
      j1 = 1;
      while D(k1).t(j1) < dn1
          j1 = j1 + 1;
      end
      
      j2 = 1;
      while D(k2).t(j2) < dn2
          j2 = j2 + 1;
      end
      
      j0 = 1;
      while D(k0).t(j0) < dnOrigin
          j0 = j0 + 1;
      end
      

      
      E = [cat(1, D(k1).t(j1:end), D(k1+1:k2-1).t, D(k2).t(1:j2)), ...
           cat(1, D(k1).d(j1:end), D(k1+1:k2-1).d, D(k2).d(1:j2))];
      
      originIndex = 1;
      while E(originIndex, 1) < dnOrigin
          originIndex = originIndex + 1;
      end
      
      % filtering
      freq=D.SampleRate;
      data=E(:,2);
      data=data-mean(data);
      fNorm = [1/(freq/2), 15/(freq/2)];[b, a] = butter(4, fNorm, 'bandpass');
      data = filtfilt(b, a, data);
      
      % size of the plot window:
      hFig = figure(1);
      set(hFig, 'Position', [100 100 1000 800]) % [x y width height]
      
      plot(E(:, 1), data) %plot(E(:, 1), E(:, 2))
      datetickzoom('x', 'HH:MM:SS')
      Torigin = datenum([year month dayOfMonth hour minute second]);
      hold on; plot([Torigin Torigin], [min(E(:,2)) max(E(:,2))])
      
      zoom on
      
      % uicontrol('Position',[20 20 200 40],'String','Ready to set time!',...
      %           'Callback','uiresume(gcbf)');
      % uiwait(gcf); 
      %      
      % [t y] = ginput(1);
      % datestr(t, 'dd-mmm-yy HH:MM:SS.FFF')
      
      display('STA\LTA')
      
      [max_t ind r sta lta] = sta_lta([E(:, 1) data], 1000, 9000, originIndex);
      
      plot([max_t max_t], [min(E(:,2)) max(E(:,2))], 'k');
      hold off;
      
      datestr(max_t, 'dd-mmm-yy HH:MM:SS.FFF')
      
      
      % Distance
      r = 6371;
      
      ind = strmatch(strtrim(D(1).StationIdentifierCode),stations,'exact') - 1;
      
      lat1 = X(f, 6);
      lon1 = X(f, 7);
      
      lat2 = locations(ind, 1);
      lon2 = locations(ind, 2);
      
      d = 2 * pi * r * distance(lat1, lon1, lat2, lon2) / 360;
      
      % Travel time
      travelTime = (max_t - dnOrigin) * 24 * 60 * 60;
      
      % Output
      fileID = fopen('output.txt','a');
      fprintf(fileID, '%i %i %i %i %i %.3f %s %s %f %.3f\r\n', ...
                      X(f, 1), ... % year
                      X(f, 2), ... % month
                      X(f, 3), ... % day
                      floor(X(f, 4) / 100), ... % hours
                      rem(X(f, 4), 100), ... % minutes
                      X(f, 5), ... % seconds
                      datestr(max_t, 'HH MM SS.FFF'), ... % arrival_time
                      strtrim(D(1).StationIdentifierCode), ... % station id code
                      d, ... % distance
                      travelTime ... % travel time
                                   );
      fclose(fileID);
      
      
      display('pause')
      %pause
      
    end

end

end
