close all;clear

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

X = xlsread('FinLocalEarthq.xls');
T = getTime(X);

Tarrivals = [];
farr = fopen('arrivals.txt', 'r');
tline = fgets(farr);
while ischar(tline)
    lineData = regexp(tline, ' ', 'split');
    if str2num(cell2mat((lineData(end)))) >= 0
        Tarrivals = [Tarrivals; lineData];
    end
    tline = fgets(farr);
end
fclose(farr);

files = dir('mseeds/*.mseed');

for i = 1 : size(files, 1)
    D = rdmseed(['mseeds/' files(i).name]);
    
    station = strtrim(D(1).StationIdentifierCode);
    
    Dd = datevec(D(1).t(1));
    
    year = Dd(1); dayOfYear = datevec2doy(Dd);
    month = Dd(2); dayOfMonth = Dd(3);
    
    inds = find(ismember(X(:, 1:3), [year month dayOfMonth], 'rows') == 1);
    X2 = X(inds, :); % X2 = events that have the same date as the mseed file
    
    for f = 1 : size(X2, 1)
        hour = floor(X2(f, 4) / 100);
        minute = rem(X2(f, 4), 100);
        second = X2(f, 5);

        % finding Tarrival
        t = -Inf;
        eventDepth = -Inf;
        epicentralDistance = -Inf;
        travelTime = -Inf;
        
        for l = 1:size(Tarrivals, 1)
            if strcmp(station, char(Tarrivals(l, 11))) == 1 && ...
               year == str2num(cell2mat(Tarrivals(l, 1))) && ...
               month == str2num(cell2mat(Tarrivals(l, 2))) && ...
               dayOfMonth == str2num(cell2mat(Tarrivals(l, 3))) && ...
               hour == str2num(cell2mat(Tarrivals(l, 4))) && ...
               minute == str2num(cell2mat(Tarrivals(l, 5))) && ...
               second == str2num(cell2mat(Tarrivals(l, 6)))
           
                travelTime = str2num(cell2mat(Tarrivals(l, 15)));
                if travelTime < -100000, continue; end
           
                arrivalHour = str2num(cell2mat((Tarrivals(l, 7))));
                arrivalMin = str2num(cell2mat((Tarrivals(l, 8))));
                arrivalSec = str2num(cell2mat((Tarrivals(l, 9))));
               
                runEventOnStation(station, year, dayOfYear, hour, minute, second, arrivalHour, arrivalMin, arrivalSec)
            end
        end
    end
end
